// This file was generated by gir (https://github.com/gtk-rs/gir)
// from gir-files (https://github.com/gtk-rs/gir-files)
// DO NOT EDIT

#[cfg(any(feature = "v0_5_8", feature = "dox"))]
use TranslationKind;
use app_stream_glib_sys;
#[cfg(any(feature = "v0_5_8", feature = "dox"))]
use glib::GString;
use glib::object::IsA;
use glib::translate::*;
use std::fmt;

glib_wrapper! {
    pub struct Translation(Object<app_stream_glib_sys::AsTranslation, app_stream_glib_sys::AsTranslationClass, TranslationClass>);

    match fn {
        get_type => || app_stream_glib_sys::as_translation_get_type(),
    }
}

impl Translation {
    #[cfg(any(feature = "v0_5_8", feature = "dox"))]
    pub fn new() -> Translation {
        unsafe {
            from_glib_full(app_stream_glib_sys::as_translation_new())
        }
    }

    #[cfg(any(feature = "v0_5_8", feature = "dox"))]
    pub fn kind_from_string(kind: &str) -> TranslationKind {
        unsafe {
            from_glib(app_stream_glib_sys::as_translation_kind_from_string(kind.to_glib_none().0))
        }
    }

    #[cfg(any(feature = "v0_5_8", feature = "dox"))]
    pub fn kind_to_string(kind: TranslationKind) -> Option<GString> {
        unsafe {
            from_glib_none(app_stream_glib_sys::as_translation_kind_to_string(kind.to_glib()))
        }
    }
}

#[cfg(any(feature = "v0_5_8", feature = "dox"))]
impl Default for Translation {
    fn default() -> Self {
        Self::new()
    }
}

pub const NONE_TRANSLATION: Option<&Translation> = None;

pub trait TranslationExt: 'static {
    #[cfg(any(feature = "v0_5_8", feature = "dox"))]
    fn get_id(&self) -> Option<GString>;

    #[cfg(any(feature = "v0_5_8", feature = "dox"))]
    fn get_kind(&self) -> TranslationKind;

    #[cfg(any(feature = "v0_5_8", feature = "dox"))]
    fn set_id(&self, id: &str);

    #[cfg(any(feature = "v0_5_8", feature = "dox"))]
    fn set_kind(&self, kind: TranslationKind);
}

impl<O: IsA<Translation>> TranslationExt for O {
    #[cfg(any(feature = "v0_5_8", feature = "dox"))]
    fn get_id(&self) -> Option<GString> {
        unsafe {
            from_glib_none(app_stream_glib_sys::as_translation_get_id(self.as_ref().to_glib_none().0))
        }
    }

    #[cfg(any(feature = "v0_5_8", feature = "dox"))]
    fn get_kind(&self) -> TranslationKind {
        unsafe {
            from_glib(app_stream_glib_sys::as_translation_get_kind(self.as_ref().to_glib_none().0))
        }
    }

    #[cfg(any(feature = "v0_5_8", feature = "dox"))]
    fn set_id(&self, id: &str) {
        unsafe {
            app_stream_glib_sys::as_translation_set_id(self.as_ref().to_glib_none().0, id.to_glib_none().0);
        }
    }

    #[cfg(any(feature = "v0_5_8", feature = "dox"))]
    fn set_kind(&self, kind: TranslationKind) {
        unsafe {
            app_stream_glib_sys::as_translation_set_kind(self.as_ref().to_glib_none().0, kind.to_glib());
        }
    }
}

impl fmt::Display for Translation {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(f, "Translation")
    }
}
